diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/examples/wireless/wifi-aggregation.cc ns-3.44/examples/wireless/wifi-aggregation.cc
--- ns-3.43/examples/wireless/wifi-aggregation.cc	2024-10-09 16:41:09.840655800 -0700
+++ ns-3.44/examples/wireless/wifi-aggregation.cc	2025-03-09 16:55:49.335371000 -0700
@@ -270,8 +270,8 @@
     uint16_t port = 9;
     UdpServerHelper serverA(port);
     ApplicationContainer serverAppA = serverA.Install(wifiStaNodes.Get(0));
-    serverAppA.Start(Seconds(0.0));
-    serverAppA.Stop(simulationTime + Seconds(1.0));
+    serverAppA.Start(Seconds(0));
+    serverAppA.Stop(simulationTime + Seconds(1));
 
     UdpClientHelper clientA(StaInterfaceA.GetAddress(0), port);
     clientA.SetAttribute("MaxPackets", UintegerValue(4294967295U));
@@ -279,13 +279,13 @@
     clientA.SetAttribute("PacketSize", UintegerValue(payloadSize));
 
     ApplicationContainer clientAppA = clientA.Install(wifiApNodes.Get(0));
-    clientAppA.Start(Seconds(1.0));
-    clientAppA.Stop(simulationTime + Seconds(1.0));
+    clientAppA.Start(Seconds(1));
+    clientAppA.Stop(simulationTime + Seconds(1));
 
     UdpServerHelper serverB(port);
     ApplicationContainer serverAppB = serverB.Install(wifiStaNodes.Get(1));
-    serverAppB.Start(Seconds(0.0));
-    serverAppB.Stop(simulationTime + Seconds(1.0));
+    serverAppB.Start(Seconds(0));
+    serverAppB.Stop(simulationTime + Seconds(1));
 
     UdpClientHelper clientB(StaInterfaceB.GetAddress(0), port);
     clientB.SetAttribute("MaxPackets", UintegerValue(4294967295U));
@@ -293,13 +293,13 @@
     clientB.SetAttribute("PacketSize", UintegerValue(payloadSize));
 
     ApplicationContainer clientAppB = clientB.Install(wifiApNodes.Get(1));
-    clientAppB.Start(Seconds(1.0));
-    clientAppB.Stop(simulationTime + Seconds(1.0));
+    clientAppB.Start(Seconds(1));
+    clientAppB.Stop(simulationTime + Seconds(1));
 
     UdpServerHelper serverC(port);
     ApplicationContainer serverAppC = serverC.Install(wifiStaNodes.Get(2));
-    serverAppC.Start(Seconds(0.0));
-    serverAppC.Stop(simulationTime + Seconds(1.0));
+    serverAppC.Start(Seconds(0));
+    serverAppC.Stop(simulationTime + Seconds(1));
 
     UdpClientHelper clientC(StaInterfaceC.GetAddress(0), port);
     clientC.SetAttribute("MaxPackets", UintegerValue(4294967295U));
@@ -307,13 +307,13 @@
     clientC.SetAttribute("PacketSize", UintegerValue(payloadSize));
 
     ApplicationContainer clientAppC = clientC.Install(wifiApNodes.Get(2));
-    clientAppC.Start(Seconds(1.0));
-    clientAppC.Stop(simulationTime + Seconds(1.0));
+    clientAppC.Start(Seconds(1));
+    clientAppC.Stop(simulationTime + Seconds(1));
 
     UdpServerHelper serverD(port);
     ApplicationContainer serverAppD = serverD.Install(wifiStaNodes.Get(3));
-    serverAppD.Start(Seconds(0.0));
-    serverAppD.Stop(simulationTime + Seconds(1.0));
+    serverAppD.Start(Seconds(0));
+    serverAppD.Stop(simulationTime + Seconds(1));
 
     UdpClientHelper clientD(StaInterfaceD.GetAddress(0), port);
     clientD.SetAttribute("MaxPackets", UintegerValue(4294967295U));
@@ -321,8 +321,8 @@
     clientD.SetAttribute("PacketSize", UintegerValue(payloadSize));
 
     ApplicationContainer clientAppD = clientD.Install(wifiApNodes.Get(3));
-    clientAppD.Start(Seconds(1.0));
-    clientAppD.Stop(simulationTime + Seconds(1.0));
+    clientAppD.Start(Seconds(1));
+    clientAppD.Stop(simulationTime + Seconds(1));
 
     if (enablePcap)
     {
@@ -336,7 +336,7 @@
         phy.EnablePcap("STA_D", staDeviceD.Get(0));
     }
 
-    Simulator::Stop(simulationTime + Seconds(1.0));
+    Simulator::Stop(simulationTime + Seconds(1));
     Simulator::Run();
 
     // Show results
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/examples/wireless/wifi-ap.cc ns-3.44/examples/wireless/wifi-ap.cc
--- ns-3.43/examples/wireless/wifi-ap.cc	2024-10-09 16:41:09.840655800 -0700
+++ ns-3.44/examples/wireless/wifi-ap.cc	2025-03-09 16:55:49.339371000 -0700
@@ -28,8 +28,8 @@
 /**
  * MAC-level TX trace.
  *
- * \param context The context.
- * \param p The packet.
+ * @param context The context.
+ * @param p The packet.
  */
 void
 DevTxTrace(std::string context, Ptr<const Packet> p)
@@ -43,8 +43,8 @@
 /**
  * MAC-level RX trace.
  *
- * \param context The context.
- * \param p The packet.
+ * @param context The context.
+ * @param p The packet.
  */
 void
 DevRxTrace(std::string context, Ptr<const Packet> p)
@@ -58,11 +58,11 @@
 /**
  * PHY-level RX OK trace
  *
- * \param context The context.
- * \param packet The packet.
- * \param snr The SNR.
- * \param mode The wifi mode.
- * \param preamble The preamble.
+ * @param context The context.
+ * @param packet The packet.
+ * @param snr The SNR.
+ * @param mode The wifi mode.
+ * @param preamble The preamble.
  */
 void
 PhyRxOkTrace(std::string context,
@@ -80,9 +80,9 @@
 /**
  * PHY-level RX error trace
  *
- * \param context The context.
- * \param packet The packet.
- * \param snr The SNR.
+ * @param context The context.
+ * @param packet The packet.
+ * @param snr The SNR.
  */
 void
 PhyRxErrorTrace(std::string context, Ptr<const Packet> packet, double snr)
@@ -96,11 +96,11 @@
 /**
  * PHY-level TX trace.
  *
- * \param context The context.
- * \param packet The packet.
- * \param mode The wifi mode.
- * \param preamble The preamble.
- * \param txPower The TX power.
+ * @param context The context.
+ * @param packet The packet.
+ * @param mode The wifi mode.
+ * @param preamble The preamble.
+ * @param txPower The TX power.
  */
 void
 PhyTxTrace(std::string context,
@@ -118,10 +118,10 @@
 /**
  * PHY state trace.
  *
- * \param context The context.
- * \param start Start time of the state.
- * \param duration Duration of the state.
- * \param state The state.
+ * @param context The context.
+ * @param start Start time of the state.
+ * @param duration Duration of the state.
+ * @param state The state.
  */
 void
 PhyStateTrace(std::string context, Time start, Time duration, WifiPhyState state)
@@ -136,7 +136,7 @@
 /**
  * Move a node position by 5m on the x axis every second, up to 210m.
  *
- * \param node The node.
+ * @param node The node.
  */
 static void
 AdvancePosition(Ptr<Node> node)
@@ -150,7 +150,7 @@
     }
     mobility->SetPosition(pos);
 
-    Simulator::Schedule(Seconds(1.0), &AdvancePosition, node);
+    Simulator::Schedule(Seconds(1), &AdvancePosition, node);
 }
 
 int
@@ -196,7 +196,7 @@
     mobility.Install(stas);
     mobility.Install(ap);
 
-    Simulator::Schedule(Seconds(1.0), &AdvancePosition, ap.Get(0));
+    Simulator::Schedule(Seconds(1), &AdvancePosition, ap.Get(0));
 
     PacketSocketAddress socket;
     socket.SetSingleDevice(staDevs.Get(0)->GetIfIndex());
@@ -208,9 +208,9 @@
 
     ApplicationContainer apps = onoff.Install(stas.Get(0));
     apps.Start(Seconds(0.5));
-    apps.Stop(Seconds(43.0));
+    apps.Stop(Seconds(43));
 
-    Simulator::Stop(Seconds(44.0));
+    Simulator::Stop(Seconds(44));
 
     Config::Connect("/NodeList/*/DeviceList/*/Mac/MacTx", MakeCallback(&DevTxTrace));
     Config::Connect("/NodeList/*/DeviceList/*/Mac/MacRx", MakeCallback(&DevRxTrace));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/examples/wireless/wifi-ap.py ns-3.44/examples/wireless/wifi-ap.py
--- ns-3.43/examples/wireless/wifi-ap.py	2024-10-09 16:41:09.840655800 -0700
+++ ns-3.44/examples/wireless/wifi-ap.py	2025-03-09 16:55:49.339371000 -0700
@@ -76,7 +76,7 @@
         if (pos.x >= 210.0)
             return;
         mob->SetPosition(pos);
-        Simulator::Schedule(Seconds(1.0), AdvancePosition, node);
+        Simulator::Schedule(Seconds(1), AdvancePosition, node);
     }"""
 )
 
@@ -124,7 +124,7 @@
     mobility.Install(stas)
     mobility.Install(ap)
 
-    ns.Simulator.Schedule(ns.Seconds(1.0), ns.cppyy.gbl.AdvancePosition, ap.Get(0))
+    ns.Simulator.Schedule(ns.Seconds(1), ns.cppyy.gbl.AdvancePosition, ap.Get(0))
 
     socket = ns.PacketSocketAddress()
     socket.SetSingleDevice(staDevs.Get(0).GetIfIndex())
@@ -136,9 +136,9 @@
 
     apps = onoff.Install(ns.NodeContainer(stas.Get(0)))
     apps.Start(ns.Seconds(0.5))
-    apps.Stop(ns.Seconds(43.0))
+    apps.Stop(ns.Seconds(43))
 
-    ns.Simulator.Stop(ns.Seconds(44.0))
+    ns.Simulator.Stop(ns.Seconds(44))
 
     #   Config::Connect("/NodeList/*/DeviceList/*/Tx", MakeCallback(&DevTxTrace));
     #   Config::Connect("/NodeList/*/DeviceList/*/Rx", MakeCallback(&DevRxTrace));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/examples/wireless/wifi-backward-compatibility.cc ns-3.44/examples/wireless/wifi-backward-compatibility.cc
--- ns-3.43/examples/wireless/wifi-backward-compatibility.cc	2024-10-09 16:41:09.840655800 -0700
+++ ns-3.44/examples/wireless/wifi-backward-compatibility.cc	2025-03-09 16:55:49.339371000 -0700
@@ -44,8 +44,8 @@
 /**
  * Convert a string (e.g., "80211a") to a pair {WifiStandard, WifiPhyBand}
  *
- * \param version The WiFi standard version.
- * \return a pair of WifiStandard, WifiPhyBand
+ * @param version The WiFi standard version.
+ * @return a pair of WifiStandard, WifiPhyBand
  */
 std::pair<WifiStandard, WifiPhyBand>
 ConvertStringToStandardAndBand(std::string version)
@@ -196,13 +196,13 @@
 
     UdpServerHelper apServer(9);
     ApplicationContainer apServerApp = apServer.Install(wifiApNode.Get(0));
-    apServerApp.Start(Seconds(0.0));
-    apServerApp.Stop(simulationTime + Seconds(1.0));
+    apServerApp.Start(Seconds(0));
+    apServerApp.Stop(simulationTime + Seconds(1));
 
     UdpServerHelper staServer(5001);
     ApplicationContainer staServerApp = staServer.Install(wifiStaNode.Get(0));
-    staServerApp.Start(Seconds(0.0));
-    staServerApp.Stop(simulationTime + Seconds(1.0));
+    staServerApp.Start(Seconds(0));
+    staServerApp.Stop(simulationTime + Seconds(1));
 
     if (apHasTraffic)
     {
@@ -211,8 +211,8 @@
         apClient.SetAttribute("Interval", TimeValue(Time("0.00001")));   // packets/s
         apClient.SetAttribute("PacketSize", UintegerValue(payloadSize)); // bytes
         ApplicationContainer apClientApp = apClient.Install(wifiApNode.Get(0));
-        apClientApp.Start(Seconds(1.0));
-        apClientApp.Stop(simulationTime + Seconds(1.0));
+        apClientApp.Start(Seconds(1));
+        apClientApp.Stop(simulationTime + Seconds(1));
     }
 
     if (staHasTraffic)
@@ -222,13 +222,13 @@
         staClient.SetAttribute("Interval", TimeValue(Time("0.00001")));   // packets/s
         staClient.SetAttribute("PacketSize", UintegerValue(payloadSize)); // bytes
         ApplicationContainer staClientApp = staClient.Install(wifiStaNode.Get(0));
-        staClientApp.Start(Seconds(1.0));
-        staClientApp.Stop(simulationTime + Seconds(1.0));
+        staClientApp.Start(Seconds(1));
+        staClientApp.Stop(simulationTime + Seconds(1));
     }
 
     Ipv4GlobalRoutingHelper::PopulateRoutingTables();
 
-    Simulator::Stop(simulationTime + Seconds(1.0));
+    Simulator::Stop(simulationTime + Seconds(1));
     Simulator::Run();
 
     double rxBytes;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/examples/wireless/wifi-blockack.cc ns-3.44/examples/wireless/wifi-blockack.cc
--- ns-3.43/examples/wireless/wifi-blockack.cc	2024-10-09 16:41:09.840655800 -0700
+++ ns-3.44/examples/wireless/wifi-blockack.cc	2025-03-09 16:55:49.339371000 -0700
@@ -150,12 +150,12 @@
 
     ApplicationContainer staApps = onOff.Install(sta);
 
-    staApps.Start(Seconds(1.0));
-    staApps.Stop(Seconds(10.0));
+    staApps.Start(Seconds(1));
+    staApps.Stop(Seconds(10));
 
     Ipv4GlobalRoutingHelper::PopulateRoutingTables();
 
-    Simulator::Stop(Seconds(10.0));
+    Simulator::Stop(Seconds(10));
 
     phy.EnablePcap("test-blockack", ap->GetId(), 0);
     Simulator::Run();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/examples/wireless/wifi-clear-channel-cmu.cc ns-3.44/examples/wireless/wifi-clear-channel-cmu.cc
--- ns-3.43/examples/wireless/wifi-clear-channel-cmu.cc	2024-10-09 16:41:09.840655800 -0700
+++ ns-3.44/examples/wireless/wifi-clear-channel-cmu.cc	2025-03-09 16:55:49.339371000 -0700
@@ -34,16 +34,16 @@
     Experiment();
     /**
      * Constructor.
-     * \param name The name of the experiment.
+     * @param name The name of the experiment.
      */
     Experiment(std::string name);
     /**
      * Run an experiment.
-     * \param wifi      //!< The WifiHelper class.
-     * \param wifiPhy   //!< The YansWifiPhyHelper class.
-     * \param wifiMac   //!< The WifiMacHelper class.
-     * \param wifiChannel //!< The YansWifiChannelHelper class.
-     * \return the number of received packets.
+     * @param wifi      //!< The WifiHelper class.
+     * @param wifiPhy   //!< The YansWifiPhyHelper class.
+     * @param wifiMac   //!< The WifiMacHelper class.
+     * @param wifiChannel //!< The YansWifiChannelHelper class.
+     * @return the number of received packets.
      */
     uint32_t Run(const WifiHelper& wifi,
                  const YansWifiPhyHelper& wifiPhy,
@@ -53,33 +53,33 @@
   private:
     /**
      * Receive a packet.
-     * \param socket The receiving socket.
+     * @param socket The receiving socket.
      */
     void ReceivePacket(Ptr<Socket> socket);
     /**
      * Set the position of a node.
-     * \param node The node.
-     * \param position The position of the node.
+     * @param node The node.
+     * @param position The position of the node.
      */
     void SetPosition(Ptr<Node> node, Vector position);
     /**
      * Get the position of a node.
-     * \param node The node.
-     * \return the position of the node.
+     * @param node The node.
+     * @return the position of the node.
      */
     Vector GetPosition(Ptr<Node> node);
     /**
      * Setup the receiving socket.
-     * \param node The receiving node.
-     * \return the socket.
+     * @param node The receiving node.
+     * @return the socket.
      */
     Ptr<Socket> SetupPacketReceive(Ptr<Node> node);
     /**
      * Generate the traffic.
-     * \param socket The sending socket.
-     * \param pktSize The packet size.
-     * \param pktCount The number of packets to send.
-     * \param pktInterval The time between packets.
+     * @param socket The sending socket.
+     * @param pktSize The packet size.
+     * @param pktCount The number of packets to send.
+     * @param pktInterval The time between packets.
      */
     void GenerateTraffic(Ptr<Socket> socket, uint32_t pktSize, uint32_t pktCount, Time pktInterval);
 
@@ -197,7 +197,7 @@
     uint32_t packetSize = 1014;
     uint32_t maxPacketCount = 200;
     Time interPacketInterval = Seconds(1.);
-    Simulator::Schedule(Seconds(1.0),
+    Simulator::Schedule(Seconds(1),
                         &Experiment::GenerateTraffic,
                         this,
                         source,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/examples/wireless/wifi-eht-network.cc ns-3.44/examples/wireless/wifi-eht-network.cc
--- ns-3.43/examples/wireless/wifi-eht-network.cc	2024-10-09 16:41:09.840655800 -0700
+++ ns-3.44/examples/wireless/wifi-eht-network.cc	2025-03-09 16:55:49.339371000 -0700
@@ -6,6 +6,7 @@
  * Author: Sebastien Deronne <sebastien.deronne@gmail.com>
  */
 
+#include "ns3/attribute-container.h"
 #include "ns3/boolean.h"
 #include "ns3/command-line.h"
 #include "ns3/config.h"
@@ -30,6 +31,7 @@
 #include "ns3/yans-wifi-channel.h"
 #include "ns3/yans-wifi-helper.h"
 
+#include <algorithm>
 #include <array>
 #include <functional>
 #include <numeric>
@@ -57,10 +59,10 @@
 NS_LOG_COMPONENT_DEFINE("eht-wifi-network");
 
 /**
- * \param udp true if UDP is used, false if TCP is used
- * \param serverApp a container of server applications
- * \param payloadSize the size in bytes of the packets
- * \return the bytes received by each server application
+ * @param udp true if UDP is used, false if TCP is used
+ * @param serverApp a container of server applications
+ * @param payloadSize the size in bytes of the packets
+ * @return the bytes received by each server application
  */
 std::vector<uint64_t>
 GetRxBytes(bool udp, const ApplicationContainer& serverApp, uint32_t payloadSize)
@@ -85,12 +87,12 @@
 
 /**
  * Print average throughput over an intermediate time interval.
- * \param rxBytes a vector of the amount of bytes received by each server application
- * \param udp true if UDP is used, false if TCP is used
- * \param serverApp a container of server applications
- * \param payloadSize the size in bytes of the packets
- * \param tputInterval the duration of an intermediate time interval
- * \param simulationTime the simulation time in seconds
+ * @param rxBytes a vector of the amount of bytes received by each server application
+ * @param udp true if UDP is used, false if TCP is used
+ * @param serverApp a container of server applications
+ * @param payloadSize the size in bytes of the packets
+ * @param tputInterval the duration of an intermediate time interval
+ * @param simulationTime the simulation time in seconds
  */
 void
 PrintIntermediateTput(std::vector<uint64_t>& rxBytes,
@@ -136,10 +138,11 @@
     bool useRts{false};
     bool use80Plus80{false};
     uint16_t mpduBufferSize{512};
+    std::string emlsrMgrTypeId{"ns3::DefaultEmlsrManager"};
     std::string emlsrLinks;
     uint16_t paddingDelayUsec{32};
     uint16_t transitionDelayUsec{128};
-    uint16_t channelSwitchDelayUsec{100};
+    Time channelSwitchDelay{"100us"};
     bool switchAuxPhy{true};
     uint16_t auxPhyChWidth{20};
     bool auxPhyTxCapable{true};
@@ -154,12 +157,15 @@
     std::string dlAckSeqType{"NO-OFDMA"};
     bool enableUlOfdma{false};
     bool enableBsrp{false};
-    int mcs{-1}; // -1 indicates an unset value
+    std::string mcsStr;
+    std::vector<uint64_t> mcsValues;
+    int channelWidth{-1};  // in MHz, -1 indicates an unset value
+    int guardInterval{-1}; // in nanoseconds, -1 indicates an unset value
     uint32_t payloadSize =
         700; // must fit in the max TX duration when transmitting at MCS 0 over an RU of 26 tones
     Time tputInterval{0}; // interval for detailed throughput measurement
-    double minExpectedThroughput{0};
-    double maxExpectedThroughput{0};
+    double minExpectedThroughput{0.0};
+    double maxExpectedThroughput{0.0};
     Time accessReqInterval{0};
 
     CommandLine cmd(__FILE__);
@@ -177,6 +183,7 @@
         "Whether the third link operates in the 2.4, 5 or 6 GHz band (0 means the device has up to "
         "two links, otherwise the band must be different than first link and second link)",
         frequency3);
+    cmd.AddValue("emlsrMgrTypeId", "The ns-3 TypeId of the EMLSR manager to use", emlsrMgrTypeId);
     cmd.AddValue("emlsrLinks",
                  "The comma separated list of IDs of EMLSR links (for MLDs only)",
                  emlsrLinks);
@@ -196,9 +203,7 @@
     cmd.AddValue("emlsrAuxTxCapable",
                  "Whether Aux PHYs are capable of transmitting.",
                  auxPhyTxCapable);
-    cmd.AddValue("channelSwitchDelay",
-                 "The PHY channel switch delay in microseconds",
-                 channelSwitchDelayUsec);
+    cmd.AddValue("channelSwitchDelay", "The PHY channel switch delay", channelSwitchDelay);
     cmd.AddValue("distance",
                  "Distance in meters between the station and the access point",
                  distance);
@@ -226,7 +231,18 @@
         "muSchedAccessReqInterval",
         "Duration of the interval between two requests for channel access made by the MU scheduler",
         accessReqInterval);
-    cmd.AddValue("mcs", "if set, limit testing to a specific MCS (0-11)", mcs);
+    cmd.AddValue(
+        "mcs",
+        "list of comma separated MCS values to test; if unset, all MCS values (0-13) are tested",
+        mcsStr);
+    cmd.AddValue("channelWidth",
+                 "if set, limit testing to a specific channel width expressed in MHz (20, 40, 80 "
+                 "or 160 MHz)",
+                 channelWidth);
+    cmd.AddValue("guardInterval",
+                 "if set, limit testing to a specific guard interval duration expressed in "
+                 "nanoseconds (800, 1600 or 3200 ns)",
+                 guardInterval);
     cmd.AddValue("payloadSize", "The application payload size in bytes", payloadSize);
     cmd.AddValue("tputInterval", "duration of intervals for throughput measurement", tputInterval);
     cmd.AddValue("minExpectedThroughput",
@@ -273,26 +289,51 @@
               << "GI"
               << "\t\t\t"
               << "Throughput" << '\n';
-    int minMcs = 0;
-    int maxMcs = 13;
-    if (mcs >= 0 && mcs <= 13)
+    uint8_t minMcs = 0;
+    uint8_t maxMcs = 13;
+
+    if (mcsStr.empty())
+    {
+        for (uint8_t mcs = minMcs; mcs <= maxMcs; ++mcs)
+        {
+            mcsValues.push_back(mcs);
+        }
+    }
+    else
     {
-        minMcs = mcs;
-        maxMcs = mcs;
+        AttributeContainerValue<UintegerValue, ',', std::vector> attr;
+        auto checker = DynamicCast<AttributeContainerChecker>(MakeAttributeContainerChecker(attr));
+        checker->SetItemChecker(MakeUintegerChecker<uint8_t>());
+        attr.DeserializeFromString(mcsStr, checker);
+        mcsValues = attr.Get();
+        std::sort(mcsValues.begin(), mcsValues.end());
     }
-    for (int mcs = minMcs; mcs <= maxMcs; mcs++)
+
+    int minChannelWidth = 20;
+    int maxChannelWidth = (frequency != 2.4 && frequency2 != 2.4 && frequency3 != 2.4) ? 160 : 40;
+    if (channelWidth >= minChannelWidth && channelWidth <= maxChannelWidth)
+    {
+        minChannelWidth = channelWidth;
+        maxChannelWidth = channelWidth;
+    }
+    int minGi = enableUlOfdma ? 1600 : 800;
+    int maxGi = 3200;
+    if (guardInterval >= minGi && guardInterval <= maxGi)
+    {
+        minGi = guardInterval;
+        maxGi = guardInterval;
+    }
+
+    for (const auto mcs : mcsValues)
     {
         uint8_t index = 0;
         double previous = 0;
-        uint16_t maxChannelWidth =
-            (frequency != 2.4 && frequency2 != 2.4 && frequency3 != 2.4) ? 160 : 40;
-        int minGi = enableUlOfdma ? 1600 : 800;
-        for (int channelWidth = 20; channelWidth <= maxChannelWidth;) // MHz
+        for (int width = minChannelWidth; width <= maxChannelWidth; width *= 2) // MHz
         {
-            const auto is80Plus80 = (use80Plus80 && (channelWidth == 160));
-            const std::string widthStr = is80Plus80 ? "80+80" : std::to_string(channelWidth);
+            const auto is80Plus80 = (use80Plus80 && (width == 160));
+            const std::string widthStr = is80Plus80 ? "80+80" : std::to_string(width);
             const auto segmentWidthStr = is80Plus80 ? "80" : widthStr;
-            for (int gi = 3200; gi >= minGi;) // Nanoseconds
+            for (int gi = maxGi; gi >= minGi; gi /= 2) // Nanoseconds
             {
                 if (!udp)
                 {
@@ -391,10 +432,10 @@
 
                 SpectrumWifiPhyHelper phy(nLinks);
                 phy.SetPcapDataLinkType(WifiPhyHelper::DLT_IEEE802_11_RADIO);
-                phy.Set("ChannelSwitchDelay", TimeValue(MicroSeconds(channelSwitchDelayUsec)));
+                phy.Set("ChannelSwitchDelay", TimeValue(channelSwitchDelay));
 
                 mac.SetType("ns3::StaWifiMac", "Ssid", SsidValue(ssid));
-                mac.SetEmlsrManager("ns3::DefaultEmlsrManager",
+                mac.SetEmlsrManager(emlsrMgrTypeId,
                                     "EmlsrLinkSet",
                                     StringValue(emlsrLinks),
                                     "EmlsrPaddingDelay",
@@ -486,8 +527,12 @@
                     clientNodes.Add(downlink ? wifiApNode.Get(0) : wifiStaNodes.Get(i));
                 }
 
-                const auto maxLoad =
-                    nLinks * EhtPhy::GetDataRate(mcs, channelWidth, NanoSeconds(gi), 1) / nStations;
+                const auto maxLoad = nLinks *
+                                     EhtPhy::GetDataRate(mcs,
+                                                         MHz_u{static_cast<double>(width)},
+                                                         NanoSeconds(gi),
+                                                         1) /
+                                     nStations;
                 if (udp)
                 {
                     // UDP flow
@@ -496,8 +541,8 @@
                     serverApp = server.Install(serverNodes.get());
                     streamNumber += server.AssignStreams(serverNodes.get(), streamNumber);
 
-                    serverApp.Start(Seconds(0.0));
-                    serverApp.Stop(simulationTime + Seconds(1.0));
+                    serverApp.Start(Seconds(0));
+                    serverApp.Stop(simulationTime + Seconds(1));
                     const auto packetInterval = payloadSize * 8.0 / maxLoad;
 
                     for (std::size_t i = 0; i < nStations; i++)
@@ -509,8 +554,8 @@
                         ApplicationContainer clientApp = client.Install(clientNodes.Get(i));
                         streamNumber += client.AssignStreams(clientNodes.Get(i), streamNumber);
 
-                        clientApp.Start(Seconds(1.0));
-                        clientApp.Stop(simulationTime + Seconds(1.0));
+                        clientApp.Start(Seconds(1));
+                        clientApp.Stop(simulationTime + Seconds(1));
                     }
                 }
                 else
@@ -522,8 +567,8 @@
                     serverApp = packetSinkHelper.Install(serverNodes.get());
                     streamNumber += packetSinkHelper.AssignStreams(serverNodes.get(), streamNumber);
 
-                    serverApp.Start(Seconds(0.0));
-                    serverApp.Stop(simulationTime + Seconds(1.0));
+                    serverApp.Start(Seconds(0));
+                    serverApp.Stop(simulationTime + Seconds(1));
 
                     for (std::size_t i = 0; i < nStations; i++)
                     {
@@ -540,8 +585,8 @@
                         ApplicationContainer clientApp = onoff.Install(clientNodes.Get(i));
                         streamNumber += onoff.AssignStreams(clientNodes.Get(i), streamNumber);
 
-                        clientApp.Start(Seconds(1.0));
-                        clientApp.Stop(simulationTime + Seconds(1.0));
+                        clientApp.Start(Seconds(1));
+                        clientApp.Stop(simulationTime + Seconds(1));
                     }
                 }
 
@@ -557,10 +602,10 @@
                                         serverApp,
                                         payloadSize,
                                         tputInterval,
-                                        simulationTime + Seconds(1.0));
+                                        simulationTime + Seconds(1));
                 }
 
-                Simulator::Stop(simulationTime + Seconds(1.0));
+                Simulator::Stop(simulationTime + Seconds(1));
                 Simulator::Run();
 
                 // When multiple stations are used, there are chances that association requests
@@ -579,7 +624,7 @@
                           << " Mbit/s" << std::endl;
 
                 // test first element
-                if (mcs == minMcs && channelWidth == 20 && gi == 3200)
+                if (mcs == minMcs && width == 20 && gi == 3200)
                 {
                     if (throughput * (1 + tolerance) < minExpectedThroughput)
                     {
@@ -588,7 +633,7 @@
                     }
                 }
                 // test last element
-                if (mcs == maxMcs && channelWidth == maxChannelWidth && gi == 800)
+                if (mcs == maxMcs && width == maxChannelWidth && gi == 800)
                 {
                     if (maxExpectedThroughput > 0 &&
                         throughput > maxExpectedThroughput * (1 + tolerance))
@@ -618,9 +663,7 @@
                     exit(1);
                 }
                 index++;
-                gi /= 2;
             }
-            channelWidth *= 2;
         }
     }
     return 0;
